﻿using MediatR;
using ProxmoxConnector.Server.Application.Utils;
using System.Threading;
using System.Threading.Tasks;

namespace ProxmoxConnector.Server.Application.Queries.System
{
    public class GetSystemVersion
    {
        public class Query : Query<Model>
        {
            public Query()
            {
            }
        }

        public class Model
        {
            public string Version { get; set; }
        }

        public class QueryHandler : IRequestHandler<Query, Model>
        {
            public QueryHandler()
            {
            }

            public async Task<Model> Handle(Query request, CancellationToken cancellationToken)
            {
                var version = SystemRegistry.GetVersion();
                var result = new Model { Version = version };
                return await Task.FromResult(result);
            }
        }
    }
}
